package net.tomatentum.cutin;

import java.lang.reflect.Method;
import java.util.List;
import java.util.Optional;


public interface ReflectedMethodFactory<I extends Object> {
    Optional<ReflectedMethod<I>> produce(Method method, Object containingClass);
    ReflectedMethodFactory<I> addFactory(Factory<I> factory);

    public interface Factory<I extends Object> {

        Optional<ReflectedMethod<I>> produce(Method method, Object containingObject);
        void addParser(ReflectedMethod<I> method, List<MethodParser> parser);

    }
}